//---------------------------------------------------------------------------

#ifndef MainH
#define MainH
//---------------------------------------------------------------------------
#include <Classes.hpp>
#include <Controls.hpp>
#include <StdCtrls.hpp>
#include <Forms.hpp>
#include <Dialogs.hpp>
#include <Menus.hpp>
#include <ExtCtrls.hpp>
#include <stdio.h>
#include <ComCtrls.hpp>
#include <ToolWin.hpp>
#include <CheckLst.hpp>
//---------------------------------------------------------------------------
class TForm1 : public TForm
{
__published:	// IDE-managed Components
        TOpenDialog *OpenDialogSMC;
        TMainMenu *MainMenu;
        TMenuItem *File1;
        TMenuItem *Open1;
        TPaintBox *PaintBox1;
        TButton *ButtonLeft;
        TButton *ButtonRight;
        TButton *ButtonUp;
        TButton *ButtonDown;
        TComboBox *ComboBoxTile;
        TComboBox *ComboBoxBack;
        TMenuItem *Save1;
        TPanel *Panel1;
        TComboBox *ComboBoxFg;
        TComboBox *ComboBoxGg;
        TComboBox *ComboBoxOb;
        TPopupMenu *PopupMenu1;
        TMenuItem *Starthere1;
        TMenuItem *Guardhere1;
        TMenuItem *Deleteguard1;
        TMenuItem *Guardtype1;
        TMenuItem *Flipstart1;
        TMenuItem *Flipguard1;
        TMenuItem *N1;
        TMenuItem *Guardskill1;
        TMenuItem *N2;
        TMenuItem *Roomlinks1;
        TComboBox *ComboBoxMod;
        TEdit *EditRm;
        TEdit *EditPs;
        TCheckBox *CheckBoxNx;
        TStatusBar *StatusBar1;
        TCheckListBox *CheckListBoxFlags;
        TMenuItem *Export1;
        TMenuItem *Import1;
        TOpenDialog *OpenDialogImport;
        TSaveDialog *SaveDialogExport;
        TLabel *Label1;
        TMenuItem *Mode1;
        TMenuItem *Automatic1;
        TMenuItem *Manual1;
        TMenuItem *N3;
        TMenuItem *Labels1;
        TMenuItem *Level1;
        TMenuItem *Clearallrooms1;
        TMenuItem *Clearthisroom1;
        TMenuItem *Jumptoroom1;
        TMenuItem *Changetype1;
        TMenuItem *Doublesize1;
        void __fastcall Open1Click(TObject *Sender);
        void __fastcall FormCreate(TObject *Sender);
        void __fastcall FormDestroy(TObject *Sender);
        void __fastcall PaintBox1Paint(TObject *Sender);
        void __fastcall ButtonLeftClick(TObject *Sender);
        void __fastcall ButtonRightClick(TObject *Sender);
        void __fastcall ButtonUpClick(TObject *Sender);
        void __fastcall ButtonDownClick(TObject *Sender);
        void __fastcall PaintBox1MouseDown(TObject *Sender,
          TMouseButton Button, TShiftState Shift, int X, int Y);
        void __fastcall ComboBoxTileDrawItem(TWinControl *Control,
          int Index, TRect &Rect, TOwnerDrawState State);
        void __fastcall ComboBoxTileChange(TObject *Sender);
        void __fastcall ComboBoxBackChange(TObject *Sender);
        void __fastcall ComboBoxBackDrawItem(TWinControl *Control,
          int Index, TRect &Rect, TOwnerDrawState State);
        void __fastcall Save1Click(TObject *Sender);
        void __fastcall ComboBoxFgDrawItem(TWinControl *Control, int Index,
          TRect &Rect, TOwnerDrawState State);
        void __fastcall ComboBoxGgDrawItem(TWinControl *Control, int Index,
          TRect &Rect, TOwnerDrawState State);
        void __fastcall ComboBoxFgChange(TObject *Sender);
        void __fastcall ComboBoxGgChange(TObject *Sender);
        void __fastcall ComboBoxObChange(TObject *Sender);
        void __fastcall Starthere1Click(TObject *Sender);
        void __fastcall Guardhere1Click(TObject *Sender);
        void __fastcall Deleteguard1Click(TObject *Sender);
        void __fastcall Flipstart1Click(TObject *Sender);
        void __fastcall Flipguard1Click(TObject *Sender);
        void __fastcall Guardtype1Click(TObject *Sender);
        void __fastcall Guardskill1Click(TObject *Sender);
        void __fastcall Roomlinks1Click(TObject *Sender);
        void __fastcall ComboBoxModChange(TObject *Sender);
        void __fastcall EditRmChange(TObject *Sender);
        void __fastcall EditPsChange(TObject *Sender);
        void __fastcall CheckBoxNxClick(TObject *Sender);
        void __fastcall CheckListBoxFlagsClick(TObject *Sender);
        void __fastcall Export1Click(TObject *Sender);
        void __fastcall Import1Click(TObject *Sender);
        void __fastcall Automatic1Click(TObject *Sender);
        void __fastcall Manual1Click(TObject *Sender);
        void __fastcall Labels1Click(TObject *Sender);
        void __fastcall Clearallrooms1Click(TObject *Sender);
        void __fastcall Clearthisroom1Click(TObject *Sender);
        void __fastcall Jumptoroom1Click(TObject *Sender);
        void __fastcall Changetype1Click(TObject *Sender);
        void __fastcall Doublesize1Click(TObject *Sender);
private:	// User declarations
public:		// User declarations
int level,rm,lasti,lastj;
void DrawRoom();
bool open;
AnsiString file;
void GetTile(int);
int Select(const char*[],int,int,AnsiString);
void GetMod(int);
void SetMod(int);
void DoAuto(int);
        __fastcall TForm1(TComponent* Owner);
};
//---------------------------------------------------------------------------
extern PACKAGE TForm1 *Form1;
//---------------------------------------------------------------------------
//#define SMCHD 0x200
int SMCHD;
#pragma pack(push,1)
typedef struct{
   unsigned char bg[24][3][10];
   unsigned char fg[24][3][10];
   unsigned char md[24][3][10];
   unsigned char block_gg[256];
   unsigned char block_fg[256];
   unsigned char block_ob[256];
   unsigned char block_fl[256];
   unsigned char rm_links[24][4];
   unsigned char start_rm,start_ps,start_dr,zero;
   unsigned char guard_ps[24];
   unsigned char guard_tp[24];
   unsigned char guard_sk[24];
   unsigned char guard_uk1[24];
   unsigned char guard_uk2[24];
   unsigned char guard_uk3[24];
   unsigned char door1[256];
   unsigned char door2[256];
}TLevel;
#if sizeof(TLevel)!=3940
#error Level size incorrect!
#endif
#pragma pack(pop)
class TSMC {
   public:
   TSMC();
   ~TSMC();
   bool opensmc(AnsiString);
   TMemoryStream* ms_smc;
   TMemoryStream** ms_data; int ndata;
   void clear();
   void openlevel(int);
   TLevel level;
   void decodelevel(TMemoryStream*,TMemoryStream*,int);
   unsigned __int16* bgblock;
   unsigned char* bgtile;
   unsigned __int16* fgblock;
   unsigned char* fgtile;
   unsigned __int16* ggblock;
   unsigned char* ggtile;
   TColor* pal,*pal2;
   void openenv(int);
   void decodeenv(TMemoryStream*,unsigned __int16**,unsigned char**,int,int,int,int,int,int,int);
   void decodearray(TMemoryStream*,int,int,unsigned __int16*);
   void decodeblock(TMemoryStream*,int,int,unsigned __int16*);
   void decodetile16(TMemoryStream*,int,unsigned char*);
   void decodetile32(TMemoryStream*,int,unsigned char*);
   void drawroom(Graphics::TBitmap*,int);
   void drawlayer(Graphics::TBitmap*,unsigned char[3][10],int,int,int,unsigned __int16*,unsigned char*,unsigned char*,unsigned char,unsigned char*);
   void drawblock(Graphics::TBitmap*,int,int,int,int,int,int,unsigned __int16*,unsigned char*,unsigned char,bool);
   void drawtile(Graphics::TBitmap*,int,int,int,int,unsigned char*,unsigned char,bool);
   void decodepal(TMemoryStream*,TColor**,int);
   bool sel[3][10];
   void brightpal(TColor*,TColor*/***/,int);
   void clearsel();
   void savelevel(int);
   void savesmc(AnsiString);
   void encodelevel(TMemoryStream*,TMemoryStream*,int);
//   unsigned __int32 lastsa;
   void decodesprite(TMemoryStream*,unsigned char**,unsigned char*,unsigned char*,unsigned char*,unsigned char*);
   void drawsprite(Graphics::TBitmap*,int,int,int,int,bool,bool);
   void decodeobj(TMemoryStream* ms_in,unsigned char**tile);
   void drawobj(Graphics::TBitmap* bm,int x0,int y0,int ix,bool sel);
   void drawanobj(Graphics::TBitmap* bm,int x0,int y0,unsigned char ch,bool sel);
   int ltype;
   void drawtorch(Graphics::TBitmap* bm,int x0,int y0,bool sel);
   bool want_label;
   void TSMC::closeenv();
};
TSMC smc;
Graphics::TBitmap* kep;
const char* ob[]={
   "(none)","01","loose","03","open","close","door","ld end",
   "mirror","skel","sword","0Btorch","chomper","guillotine","spike","0F",
   "crusher","11","heal potion","life potion","hurt potion","upside down potion","slow fall potion","debris",
   "door top","fire","potion of warp","1Bdown only","kill potion","1Dtorch","log","1F",
   "stars","21torch","22torch","teleport","ld begin","25","26","lava",
   "skel cont","skull?",">>>","<<<"};
const char* gu[]={
//   "00","skel","golden skel","golden skel","girl","fat","shadow","green",
//   "greenish blue","blue","red","purple","0C","red l","blue l","x"
   "[BAD] prince garbage","[BAD] freeze","dead purple","skel","brown skel","golden skel","girl","fat",
   "shadow","green","greenish blue","blue","red","purple","blueface","red knight",
   "blue knight","monster","Jaffar","dead","[BAD]","[BAD]","[BAD] freeze","[BAD] torture","[BAD] freeze"
};
const int gu_sp[]={
   -1,-1,259,323,323,323,951,227,
   14,259,259,259,259,259,259,355,
   355,1002,387,-1,-1,-1,-1,-1
};
const int gu_pl[]={
   -1,-1,3,4,5,6,8,9,
   10,11,12,13,14,15,16,17,
   18,19,20,-1,-1,-1,-1,-1
};
const char* levels[]={
   "LEVEL 1","LEVEL 2","LEVEL 3","LEVEL 4","LEVEL 5","LEVEL 6","LEVEL 7","LEVEL 8",
   "LEVEL 9","LEVEL 10","LEVEL 11","LEVEL 12","LEVEL 13","LEVEL 14","LEVEL 15","LEVEL 16",
   "LEVEL 17","LEVEL 18","LEVEL 19","LEVEL 20","Jaffar","Demo","TRAINING 1","TRAINING 2",
   "TRAINING 3","TRAINING 4","TRAINING 5"
};
const char* ltypes[]={
   "blue dungeon","pink palace","grey palace","red dungeon","green palace","brown dungeon",
   "red palace","level 20","jaffar","demo red palace"
};
bool amode=true;
int scale=1;
#endif

